package esempio2;

import static org.junit.jupiter.api.Assertions.assertEquals;
import static org.mockito.ArgumentMatchers.anyString;
import static org.mockito.Mockito.times;
import static org.mockito.Mockito.verify;
import static org.mockito.Mockito.when;

import java.util.ArrayList;
import java.util.List;

import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;
import org.mockito.InjectMocks;
import org.mockito.MockitoAnnotations;
import org.mockito.Spy;

class TestDistributoreCaramelle {

	@Spy
	List<String> caramelle = new ArrayList<>();
	
	@InjectMocks
	DistributoreCaramelle distributore;
	
	@BeforeEach
	public void setup() {
		MockitoAnnotations.openMocks(this);
	}
	
	@Test
	public void testFill1() {
		distributore.fill(2, "Fragola");
		
		verify(caramelle, times(1)).size();
		verify(caramelle, times(2)).add(anyString());
		
		assertEquals("Fragola", caramelle.get(0));
	}
	
	@Test
	public void testFill2() {
		when(caramelle.size()).thenReturn(10);
		
		distributore.fill(2, "Limone");
		
		verify(caramelle, times(1)).size();
		verify(caramelle, times(0)).add(anyString());
	}
	
	@Test
	public void testGetCandy1() {
		distributore.fill(2, "Limone");
		distributore.fill(3, "Fragola");
		
		verify(caramelle, times(5)).add(anyString());
		verify(caramelle, times(3)).add("Fragola");
		
		distributore.getCandy("Fragola");
		
		verify(caramelle, times(1)).remove("Fragola");
		verify(caramelle, times(0)).remove("Limone");
		assertEquals(4, caramelle.size());
	}
	
	@Test
	public void testGetCandy2() {
		distributore.fill(2, "Limone");
		
		verify(caramelle, times(2)).add("Limone");
		
		distributore.getCandy("Fragola");
		
		verify(caramelle, times(0)).remove("Fragola");
		assertEquals(2, caramelle.size());
	}
	
	@Test
	public void testGetCandy3() {		
		distributore.getCandy("Fragola");
		
		verify(caramelle, times(0)).remove("Fragola");
		assertEquals(0, caramelle.size());
	}

}
